using JiShe.CollectBus.Common.Consts;
using JiShe.CollectBus.Common.Enums;
using JiShe.CollectBus.Common.Extensions;
using JiShe.CollectBus.Common.Helpers;
using JiShe.CollectBus.IotSystems.Ammeters;
using JiShe.CollectBus.IotSystems.Devices;
using JiShe.CollectBus.Protocol.Contracts.Protocol.Dto;
using JiShe.CollectBus.Protocol.Dto;
using JiShe.CollectBus.Protocol.Interfaces;
using JiShe.CollectBus.Protocol.T37612012.Appendix;
using JiShe.CollectBus.Protocol3761;
using Microsoft.Extensions.Logging;
using System.Collections.Generic;
using System.Diagnostics.Metrics;
using static FreeSql.Internal.GlobalFilter;

namespace JiShe.CollectBus.Protocol.T37612012.AnalysisData.AFN_0CH
{
    /// <summary>
    /// 5.12.2.4.101 F145：当月正向有功最大需量及发生时间（总、费率 1～M）
    /// </summary>
    public class AFN12_F145_Analysis : IAnalysisStrategy<TB3761>
    {
        private readonly ILogger<AFN12_F145_Analysis> _logger;
        private readonly AnalysisStrategyContext _analysisStrategyContext;
        private readonly DataStorage _dataStorage;
        public AFN12_F145_Analysis(ILogger<AFN12_F145_Analysis> logger, AnalysisStrategyContext analysisStrategyContext, DataStorage dataStorage)
        {
            _logger = logger;
            _analysisStrategyContext = analysisStrategyContext;
            _dataStorage = dataStorage;
        }


        public async Task<bool> ExecuteAsync(TB3761 input, Action<dynamic>? result = null)
        {
            try
            {
                ArgumentNullException.ThrowIfNull(input);
                ArgumentNullException.ThrowIfNull(input.A.Code);
                ArgumentNullException.ThrowIfNull(input.UnitData?.HexMessageList);
                List<string> datas = await AnalysisDataUnitAsync(input.UnitData.HexMessageList);
                string itemType = $"{input.AFN_FC.AFN.HexToDecStr().PadLeft(2, '0')}_{input.DT.Fn}";

                AnalysisBaseDto<decimal?> data = GenerateFinalResult(datas, "当月正向有功最大需量及发生时间", itemType);
                // 查询设备信息
                DeviceInfo? deviceInfo = await _dataStorage.GetDeviceInfoAsync(input.A.Code, input.DA.Pn);
                if (deviceInfo != null)
                {
                    data.ProjectId = deviceInfo.ProjectID;
                    data.DeviceId = deviceInfo.MeterId;
                    data.DatabaseBusiID = deviceInfo.DatabaseBusiID;
                    data.DeviceAddress = deviceInfo.MeterAddress;
                    data.FocusId = deviceInfo.FocusId;
                }

                UnitDataAnalysis<AnalysisBaseDto<decimal?>> unitDataAnalysis = new UnitDataAnalysis<AnalysisBaseDto<decimal?>>
                {
                    Code = input.A.Code!,
                    AFN = input.AFN_FC.AFN,
                    Fn = input.DT.Fn,
                    Pn = input.DA.Pn,
                    Data = data,
                    ReceivedHexMessage = input.BaseHexMessage.HexMessageString,
                    MessageId = input.MessageId,
                    ReceivedTime = input.ReceivedTime,
                    DensityUnit = DensityUnit.Second,
                    TimeDensity = 0,
                    DataType = IOTDBDataTypeConst.Data,
                };
                result?.Invoke(unitDataAnalysis);
                await _dataStorage.SaveDataToIotDbAsync(unitDataAnalysis);
                return await Task.FromResult(true);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, $"0C_145解析失败:{input.A.Code}-{input.DT.Fn}-{input.BaseHexMessage.HexMessageString},{ex.Message}");

            }
            return await Task.FromResult(false);

        }

        private async Task<List<string>> AnalysisDataUnitAsync(List<string> hexMessageList)
        {
            List<string> values = new List<string>();
            values.Add(hexMessageList.GetReadTime(4, 5));
            int ratingCount = hexMessageList.GetRatingCount(9, 1);
            values.Add(ratingCount.ToString());
            for (int i = 0; i < ratingCount + 1; i++)
            {
                var arr = hexMessageList.GetRange(10 + i * 7, 3);
                var errorCode = arr.CheckErrorCode();
                if (errorCode != null)
                    values.Add(errorCode.Item1);
                else
                {
                    await _analysisStrategyContext.ExecuteAsync<List<string>>(nameof(Appendix_A23), arr, (value) =>
                    {
                        values.Add(value.ToString());
                    }); //正向有功总最大需量
                }
                arr = hexMessageList.GetRange(10 + i * 7 + 3, 4);

                 errorCode = arr.CheckErrorCode();
                if (errorCode != null)
                    values.Add(errorCode.Item1);
                else
                {
                    await _analysisStrategyContext.ExecuteAsync<List<string>>(nameof(Appendix_A17), arr, (value) =>
                    {
                        values.Add(value.ToString());
                    });//正向有功总最大需量发生时间
                }
            }
            return values;
        }

        public AnalysisBaseDto<decimal?> GenerateFinalResult(List<string> data, string filedDesc,string itemType)
        {
            AnalysisBaseDto<decimal?> dto = new AnalysisBaseDto<decimal?>
            {
                DeviceType = MeterTypeEnum.Ammeter
            };
            var errorCode = data[2].CheckErrorCode();
            if (errorCode != null)
            {
                dto.ErrorCodeMsg = errorCode.Item2;
                dto.ValidData = false;
            }
            else
            {
                if(decimal.TryParse(data[2], out decimal value))
                    dto.DataValue = value;
            }
                
            string timeSpan = $"{DateTime.Now.Year}-{data[3].Substring(0, 2)}-{data[3].Substring(2, 2)} {data[3].Substring(4, 2)}:{data[3].Substring(6, 2)}:00";
            if (DateTime.TryParse(timeSpan, out DateTime readingDate))
            {
                dto.TimeSpan = readingDate;
            }
            dto.ItemType = itemType;
            dto.FiledDesc = filedDesc;
            dto.FiledName = dto.ItemType.GetDataFieldByGatherDataType() ?? string.Empty;
            return dto;
        }

     
    }
}
